summaryrefslogtreecommitdiff
path: root/regress/usr.bin
diff options
context:
space:
mode:
authorMarkus Friedl <markus@cvs.openbsd.org>2003-06-26 14:23:11 +0000
committerMarkus Friedl <markus@cvs.openbsd.org>2003-06-26 14:23:11 +0000
commitf41cae27a83565a7e295fd76649f50f25047d575 (patch)
treef17fda2d01ce7ca4cf233f3e821580949463ee86 /regress/usr.bin
parent8f14ea4313f3d42b7cf3e51e80caab45b072b6f2 (diff)
test -D with socks; dtucker@zip.com.au
Diffstat (limited to 'regress/usr.bin')
-rw-r--r--regress/usr.bin/ssh/dynamic-forward.sh37
1 files changed, 37 insertions, 0 deletions
diff --git a/regress/usr.bin/ssh/dynamic-forward.sh b/regress/usr.bin/ssh/dynamic-forward.sh
new file mode 100644
index 00000000000..90a2ab225eb
--- /dev/null
+++ b/regress/usr.bin/ssh/dynamic-forward.sh
@@ -0,0 +1,37 @@
+# $OpenBSD: dynamic-forward.sh,v 1.1 2003/06/26 14:23:10 markus Exp $
+# Placed in the Public Domain.
+
+tid="dynamic forwarding"
+
+PORT=4242
+FWDPORT=4243
+
+if [ -x `which nc` ] && nc -h 2>&1 | grep "x proxy address" >/dev/null; then
+ proxycmd="nc -x 127.0.0.1:$FWDPORT -X"
+elif [ -x `which connect` ]; then
+ proxycmd="connect -S 127.0.0.1:$FWDPORT -"
+else
+ echo "skipped (no suitable ProxyCommand found)"
+ exit 0
+fi
+trace "will use ProxyCommand $proxycmd"
+
+start_sshd
+
+for p in 1 2; do
+ for s in 4; do
+ for h in 127.0.0.1 localhost; do
+ trace "testing ssh protocol $p socks version $s host $h"
+ trace "start dynamic forwarding, fork to background"
+ ${SSH} -$p -F $OBJ/ssh_config -f -D $FWDPORT somehost sleep 10
+
+ trace "transfer over forwarded channel and check result"
+ ${SSH} -F $OBJ/ssh_config -o "ProxyCommand ${proxycmd}${s} $h $PORT" \
+ somehost cat /bin/ls > $OBJ/ls.copy
+ test -f $OBJ/ls.copy || fail "failed copy /bin/ls"
+ cmp /bin/ls $OBJ/ls.copy || fail "corrupted copy of /bin/ls"
+
+ sleep 10
+ done
+ done
+done